//import java.lang.*;
import java.util.*;

/*
 * Function
 */
public class Function{

	SpreadSheetCanvas ssc;

	public Function(){
	}

	public Function(SpreadSheetCanvas s){
		ssc = s;
	}

	private boolean isCell(String s){
		try{
			char c = s.charAt(0);
			int rest = Integer.parseInt(s.substring(1));
			if((c >= 'A') && (c <= 'Z') && (rest >= 0) && (rest <= Integer.MAX_VALUE)){
				return true;
			}else{
				return false;
			}
		}catch (Exception e){
			return false;
		}
	}
	
	public double evaluate(String func, double value){
		if(func.equals("SQRT")){
			return (Math.sqrt(value));
		}else if(func.equals("ABS")){
			return (Math.abs(value));
		}else if(func.equals("ACOS")){
			return (Math.acos(value));
		}else if(func.equals("ASIN")){
			return (Math.asin(value));
		}else if(func.equals("ATAN")){
			return (Math.atan(value));
		}else if(func.equals("CEIL")){
			return (Math.ceil(value));
		}else if(func.equals("COS")){
			return (Math.cos(value));
		}else if(func.equals("EXP")){
			return (Math.exp(value));
		}else if(func.equals("FLOOR")){
			return (Math.floor(value));
		}else if(func.equals("LOG")){
			return (Math.log(value));
		}else if(func.equals("ROUND")){
			return (Math.round(value));
		}else if(func.equals("SIN")){
			return (Math.sin(value));
		}else if(func.equals("TAN")){
			return (Math.tan(value));
		}else{
			return 0;
		}
	}

	public double evaluate(String func, String range){
		try{
			StringTokenizer st = new StringTokenizer(range, ":");
			String leftCell = st.nextToken();
			String rightCell = st.nextToken();
			//System.out.println("eval: " + range + " left: " + leftCell + " right: " + rightCell);
			if((isCell(leftCell)) && (isCell(rightCell))){
				if(func.equals("SUM")){
					return (sum(leftCell, rightCell));
				}else if(func.equals("AVG")){
					return (avg(leftCell, rightCell));
				}else if(func.equals("MAX")){
					return (max(leftCell, rightCell));
				}else if(func.equals("MIN")){
					return (min(leftCell, rightCell));
				}else{
					return 0;
				}
			}else{
				return 0;
			}
		}catch (Exception e){
			return 0;
		}
	}

	public double sum(String lower, String upper){
		try{
			int lc = lower.charAt(0) - 'A';
			int uc = upper.charAt(0) - 'A';
			int lr = Integer.parseInt(lower.substring(1)) - 1;
			int ur = Integer.parseInt(upper.substring(1)) - 1;
			double total = 0;

			if((lc <= uc) && (lr <= ur)){
				for(int c = lc; c <= uc; c++){
					for(int r = lr; r <= ur; r++){
						total += ssc.getCellValue(r, c);
					}
				}
			}else{
				return 0;
			}

			return total;
		}catch (Exception e){
			return 0;
		}
	}

	private int countCells(String lower, String upper){
		try{
			int lc = lower.charAt(0) - 'A';
			int uc = upper.charAt(0) - 'A';
			int lr = Integer.parseInt(lower.substring(1)) - 1;
			int ur = Integer.parseInt(upper.substring(1)) - 1;
			int count = 0;

			if((lr <= ur) && (lc <= uc)){
				for(int c = lc; c <= uc; c++){
					for(int r = lr; r <= ur; r++){
						count++;
					}
				}
			}else{
				return 0;
			}
			return count;
		}catch (Exception e){
			return 0;
		}
	}

	public double avg(String lower, String upper){
		try{
			double total = sum(lower, upper);
			int count = countCells(lower, upper);
			if(count != 0){
				return (total/count);
			}else{
				return 0;
			}
		}catch (Exception e){
			return 0;
		}
	}

	public double max(String lower, String upper){
		double max = Double.MIN_VALUE;
		try{
			int lc = lower.charAt(0) - 'A';
			int uc = upper.charAt(0) - 'A';
			int lr = Integer.parseInt(lower.substring(1)) - 1;
			int ur = Integer.parseInt(upper.substring(1)) - 1;
			double num;

			if((lr <= ur) && (lc <= uc)){
				for(int c = lc; c <= uc; c++){
					for(int r = lr; r <= ur; r++){
						num = ssc.getCellValue(r, c);
						if (num > max){
							max = num;
						}
					}
				}
			}else{
				return 0;
			}
			return max;
		}catch (Exception e){
			return max;
		}
	}

	public double min(String lower, String upper){
		double min = Double.MAX_VALUE;
		try{
			int lc = lower.charAt(0) - 'A';
			int uc = upper.charAt(0) - 'A';
			int lr = Integer.parseInt(lower.substring(1)) - 1;
			int ur = Integer.parseInt(upper.substring(1)) - 1;
			double num;

			if((lr <= ur) && (lc <= uc)){
				for(int c = lc; c <= uc; c++){
					for(int r = lr; r <= ur; r++){
						num = ssc.getCellValue(r, c);
						if (num < min){
							min = num;
						}
					}
				}
			}else{
				return 0;
			}
			return min;
		}catch (Exception e){
			return min;
		}
	}



}
