import java.applet.Applet;
import java.awt.*;
//import java.lang.*;

public class SpreadSheet extends Applet { 

	SpreadSheetCanvas ssc;
	InputField inputF;
	Panel p;
	Panel buttonPanel;

	Button copyButton;
	Button pasteButton;
	Button cutButton;
	Button clearButton;
	Button insertRowButton;
	Button insertColumnButton;
	Button removeRowButton;
	Button removeColumnButton;

	Frame f;

	ScrollPane scroller;

	public synchronized void init() {
		
		int rows, columns;
		String title;
		String rs;	//temp storage for applet parameters "row" & "column"

		title = getParameter("title");
		if (title == null) {			
			title = "Spreadsheet Applet";
		}

		rs = getParameter("rows");
		if (rs == null) {
		  rows = 10;
		}else {
			rows = Integer.parseInt(rs);
		}

		rs = getParameter("columns");
		if (rs == null) {
			columns = 5;
		}else {
		  columns = Integer.parseInt(rs);
			if (columns > 26) { //max columns of 26
				System.out.println("Columns not allowed to be > 26");
				System.out.println("Columns will be set to 26");
				columns = 26;	
			} 
		}

		f = getFrame();
		f.setTitle(title);

		ssc = new SpreadSheetCanvas(rows, columns, this);
		//ssc.setSize((ssc.cellWidth*columns) + ssc.rowLabelWidth, (ssc.cellHeight)*(rows+1));

		//create a very large canvas so that additional rows and columns can be added
		ssc.setSize(ssc.cellWidth*26 + ssc.rowLabelWidth, (ssc.cellHeight * 101));
		inputF = new InputField(ssc, 80);
		ssc.setInputField(inputF);

		//populate spreadsheet for demo purposes
		for(int i=0; i<rows;i++){
			for(int j=0; j < columns; j++){ 				
				if((i%4) == 0){
					ssc.setCellValue(i, j, "Testing "+ (i+1)*(j+1));
				}else if((i==3) && (j==2)){
					ssc.setCellValue(i, j, "=@avg(d1:d3)");
				}else{
					ssc.setCellValue(i, j, Math.round(100*Math.random()));
				}
			}
		}

		buttonPanel = new Panel();
		buttonPanel.setLayout(new GridLayout(8, 1, 4, 1));

		copyButton = new Button("Copy");
		pasteButton = new Button("Paste");
		cutButton = new Button("Cut");
		clearButton = new Button("Clear");
		insertRowButton = new Button("Insert Row");
		insertColumnButton = new Button("Insert Column");
		removeRowButton = new Button("Remove Row");
		removeColumnButton = new Button("Remove Column");

		buttonPanel.add(copyButton);
		buttonPanel.add(pasteButton);
		buttonPanel.add(cutButton);
		buttonPanel.add(clearButton);
		buttonPanel.add(insertRowButton);
		buttonPanel.add(insertColumnButton);
		buttonPanel.add(removeRowButton);
		buttonPanel.add(removeColumnButton);

		p = new Panel();
		p.setLayout(new BorderLayout());

		p.add("North", inputF);

		scroller = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
		scroller.add(ssc);

		Adjustable vadjust = scroller.getVAdjustable();
		Adjustable hadjust = scroller.getHAdjustable();
		hadjust.setUnitIncrement(10);
		vadjust.setUnitIncrement(10);

		scroller.setSize(600, 350);

		p.add("Center", scroller);

		this.setLayout(new BorderLayout());
		this.add("Center", p);
		this.add("West", buttonPanel);

		f.setResizable(true);
	}

	protected Frame getFrame(){
		Frame fr = null;

		if ( fr == null ){
			Component c = this;
			while ( c != null && ! (c instanceof Frame) ){
				c = c.getParent();
			}
			fr = (Frame) c;		  
		}
		return fr;
	}

	public void start(){
	}

	public void stop(){
	}

	public boolean action(Event evt, Object what){
		if("Copy".equals(what)){
			ssc.handleCopy();
		}else if("Paste".equals(what)){
			ssc.handlePaste();
		}else if("Cut".equals(what)){
			ssc.handleCut();
		}else if("Clear".equals(what)){
			ssc.handleClear();
		}else if("Insert Row".equals(what)){
			ssc.handleInsertRow();
		}else if("Insert Column".equals(what)){
			ssc.handleInsertColumn();
		}else if("Remove Row".equals(what)){
			ssc.handleRemoveRow();
		}else if("Remove Column".equals(what)){
			ssc.handleRemoveColumn();
		}
		return true;
	}

}
